/*
 * Lua Commander - Double Linked List Functions (unfinished).
 *
 * Copyright (C) 1999-2000, Antonio E. Scuri, Tecgraf/PUC-Rio.
 */


#ifndef _UTL_DLIST_H
#define _UTL_DLIST_H

#ifdef __cplusplus
extern "C" {
#endif


typedef struct _utlDListNode
{
  struct _utlDListNode *next;
  struct _utlDListNode *previous;
  void *value;
} utlDListNode;

typedef struct _utlDList
{
  int total;
  utlDListNode *top;
  utlDListNode *bottom;
} utlDList;

utlDList* utlCreateDList(void);
void utlKillDList(utlDList *list, void (*free_value)(void *value));

void utlDListInsertBottom(utlDList *list, void *value);

#ifdef __cplusplus
}
#endif

#endif
